package com.huimv.eartag.service.impl;

import com.huimv.common.date.DateUtil;
import com.huimv.common.result.Result;
import com.huimv.eartag.pojo.EartagData;
import com.huimv.eartag.service.EartagDataService;
import com.huimv.eartag.utils.Const;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.text.ParseException;
import java.util.Date;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@Slf4j
@Component
public class ReceivePackageSerivce {

    @Autowired
    private EartagDataService eartagDataService;
    /**
     * @Method      : handleEartagData
     * @Description : 处理耳标数据
     * @Params      : [clientMessageArray]
     * @Return      : java.lang.String
     * 
     * @Author      : ZhuoNing
     * @Date        : 2021/1/16       
     * @Time        : 12:08
     */
    public Result handleEartagData(String[] clientMessageArray) throws ParseException {
        log.info("开始添加耳标数据......");
        String commandHeader = clientMessageArray[0];
        String deviceId = clientMessageArray[1];
        String cmd = clientMessageArray[2];
        String version = clientMessageArray[3];
        String eartagId = clientMessageArray[4];
        String serial = clientMessageArray[5];
        String dl = clientMessageArray[6];
        String nbwd = clientMessageArray[7];
        String ntc = clientMessageArray[8];
        String ebwd = "";
        String ydl = clientMessageArray[9];
        String cqs = clientMessageArray[10];
        String rssi = clientMessageArray[11];
        String timestamp = clientMessageArray[12];
        String checkNumber = clientMessageArray[13];
        String commandTail = clientMessageArray[14];

        //
        EartagData eartagData = new EartagData();
        eartagData.setHeader(commandHeader);
        eartagData.setCMD(Integer.parseInt(cmd));
        eartagData.setSBID(Integer.parseInt(deviceId));
        eartagData.setVersion(version);
        eartagData.setSerial(Integer.parseInt(serial));
        eartagData.setEartagId(eartagId);
        eartagData.setDl(Integer.parseInt(dl));
        eartagData.setNBWD(Integer.parseInt(nbwd));
        eartagData.setEBWD(0.0);
        eartagData.setNtc(Integer.parseInt(ntc));
        eartagData.setYDL(Integer.parseInt(ydl));
        eartagData.setCQS(Integer.parseInt(cqs));
        eartagData.setRSSYI(Integer.parseInt(rssi));
        eartagData.setTimestamp(DateUtil.parseDateTime(DateUtil.buildDateTimeString(timestamp)));
        eartagData.setCheckNumber(Integer.parseInt(checkNumber));
        eartagData.setMLW(commandTail);
        // 保存耳标数据
        eartagDataService.add(eartagData);
        log.info(Const.EARTAG_SAVE_SUCCESS);
        return new Result(10000,Const.EARTAG_SAVE_SUCCESS,true);
    }

    /**
     * @Method      : _handleEartagDampness
     * @Description : 处理耳标湿度
     * @Params      : [clientMessageArray]
     * @Return      : java.lang.String
     *
     * @Author      : ZhuoNing
     * @Date        : 2021/1/15
     * @Time        : 17:47
     */
    public String handleEartagDampness(String[] clientMessageArray) {

        return null;
    }

    /**
     * @Method      : _handleEartagTemperature
     * @Description : 处理耳标温度
     * @Params      : [clientMessageArray]
     * @Return      : java.lang.String
     *
     * @Author      : ZhuoNing
     * @Date        : 2021/1/15
     * @Time        : 17:46
     */
    public String handleEartagTemperature(String[] clientMessageArray) {

        return null;
    }
}
